import javax.microedition.lcdui.*;
import java.util.*;

public class ElementList extends List implements CommandListener { 
 midlet midlet;
 Displayable parent;
 Vector values;
 int all=0;

 ElementList (midlet midlet, Displayable parent, String pattern) { 
  super ("", IMPLICIT);
  this.midlet = midlet;
  this.parent = parent;
  addCommand(midlet.BACK_CMD); 
  values=new Vector();
  setCommandListener (this);
  Display.getDisplay(midlet).setCurrent(this);
  search (pattern);
 }

 public static String upperStr =
  "ABWGDEVZIJKLMNOPRSTUFHCQYXŨ";
 public static String lowerStr =
  "abwgdevzijklmnoprstufhcqyx";
 public String toUpperCase(String in) {
  String out="";
  char c; 
  int n,l=in.length();
  for (int i=0; i<l; i++) {
   c=in.charAt (i);
   n=lowerStr.indexOf(c);
   if (n>-1) out+=upperStr.charAt(n);
   else out+=c;
  }
  return out;
 }

 public void search (String pattern) {
  pattern = toUpperCase(pattern.trim());
  String key, value;
  boolean go=false,noMemory=false;
  int n=midlet.keys.size(),p=0,f=0;
  for (int i=0; i<n; i++) {
   go=false;
   key=midlet.keys.elementAt(i).toString();
   value=midlet.values.elementAt(i).toString();
   if (toUpperCase(key).indexOf(pattern)>-1) { go=true; }
   else if (SearchBox.extended==true) {
    if (toUpperCase(value).indexOf(pattern)>-1) { go=true; }
   }
   if (go==true) {
    try {
     append (key,null);
     values.addElement(value);
     f++;
    }
    catch (java.lang.OutOfMemoryError mem) {
     try { delete (f-1); } catch (IndexOutOfBoundsException ie) {}
     values.setSize (f-1);
     noMemory = true;
     Runtime.getRuntime().gc();
     break;
    }
   }
   if (i%10==0) {
    if ((i*100)/n>p) {
     p=(i*100)/n;
     setTitle (Settings.SearchHdr+p+"%");
    }
   }
  }
  setTitle (Settings.FoundHdr+" ("+f+")");
  if (noMemory==true) {
   new Message (midlet, this, Settings.ErrorName).show (Settings.NoMemoryStr); 
  }
 }

 public void commandAction(Command c, Displayable d) {
  if (c == midlet.BACK_CMD) { 
   Display.getDisplay(midlet).setCurrent(parent);
  } 
  else { 
   int n=getSelectedIndex();
   new ElementForm (getString(n),values.elementAt(n).toString(), midlet, this);
  }
 }

}